#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "global.h"
/*These statements get rid of things that are not
need and are in the allegro library*/
#define alleg_gui_unused

#define alleg_vidmem_unused
#define alleg_flic_unused

#include "allegro.h"


#define END 3

BITMAP *buffer;
BITMAP *title_text;
BITMAP *comp_text;

BITMAP *statistics;
BITMAP *news_alert;
BITMAP *news_alert2;


int population= 0;
int infected=0;
int rioters=0;
int dead=0;
int score=0;
int selection=0;

int news_alert_selection=0;
int allow_switching=TRUE;

struct XANDY
{
	int x;
	int y;
};

struct CITIES
{
	struct XANDY pos;
	int population;
	int infected;
	int dead;
	int rioters;
	char name[5];
	float spread_chance;
};
struct CITIES city[10]={
	
	/*x,y,pop, name*/
	{535,90,200000,0,0,0,"A",0},
	{496,51,80000,0,0,0,"B",0},
	{453,76,90000,0,0,0,"C",0},
	{502,111,50000,0,0,0,"D",0},
	{561,168,10000,0,0,0,"E",0},
	{492,185,60000,0,0,0,"F",0},
	{638,232,23000,0,0,0,"G",0},
	{663,103,10000,0,0,0,"H",0},
	{604,52,9000,1,0,0,"I",0},
	
};

DATAFILE *datafile;
#include "datafile.h"

#ifndef M_PI
   #define M_PI   3.1415926535897932384626433832795
#endif
#define RAD_2_DEG(x) ((x) * 180 / M_PI)
#define DEG_2_RAD(x)    ((x) * M_PI / 180)

volatile frame_count=0, framecheck=0,fps=0;

volatile float title_running=0;



int show_title=TRUE;
int show_in_game_title=TRUE;
int game_1_over=FALSE;
int mouse_type=5;

int channel=3;
int one_shot_click=0;

int target_x=0;
int target_y=0;
int target=FALSE;

#define POPULATION 0
#define VIRUS 1
#define RIOTS 2

int filter=0;




MATRIX_f matrix_display;


V3D_f vtx[4];

V3D_f vtx_text[4]={
   /* x, y,   z, u, v, c     */
	{300,  0,    0, 0, 0, 128},
	{0,  600,   0, 0, 128, 128},
	{800, 600,   0, 256, 128, 128},
	{500, 0,    0, 256, 0, 128}
			};
/*
V3D_f comp_text[4]={
   /* x, y,   z, u, v, c     */ /*
	{43,  317,    0, 0, 0, 128},
	{0,  460,   0, 0, 128, 128},
	{750, 460,   0, 256, 128, 128},
	{750, 0,    0, 256, 0, 128}
			};*/
#define MAX_SCROLL 4

struct SCROLLBARS
{
	int x;
	int y;
	int w;
	int h;
	int color;
	float value;
	char text[20];
};


struct SCROLLBARS scrollbars[4] =
{
   /* (x)   (y)   (w)   (h)     color  value,text */
	{ 50,    500,    100,    25,    0, 0.50,"COMPUTE POWER"},
	{ 50,    550,    100,    25,    0, 0.50,"CONNECTION SPEED"},
	{ 200,    500,    100,    25,    0, 0.0,"LOOKS"  },
	{ 200,    550,    100,    25,    0, 0.5,"FAN SPEED"  }
};

#define MAX_COMPUTER_TALK 26
char computer_talk[MAX_COMPUTER_TALK][32]=
{
	{"HELLO"}, /*0*/
	{"I AM THE SUPER COMPUTER"},/*1*/
	{"NICE TO MEET YOU"},/*2*/
	{" "},/*3*/
	{"PLEASE"},/*4*/
	{"WATCH I DON'T OVERHEAT!"},/*5*/
	{" "},/*6*/
	{"IF I AM OVERWORKED"},/*7*/
	{"I WILL NEED COOLING "},/*8*/
	{"WHILE MY FAN IS TURNED UP"},/*9*/
	{"I WILL DO LESS WORK"},/*10*/
	{" "},/*11*/
	{"IF TEMPERATURE"},/*12*/
	{"HIGH I MAY OVERLOAD"},/*13*/
	{"FOR A WHILE"},/*14*/
	{""},/*15*/
	{""},/*16*/
	{"WATCH NEWS FOR"},/*17*/
	{"ALERTS"},/*18*/
	{" "},/*19*/
	{"CLICK SATELLITE MAP ABOVE"},/*20*/
	{"TO TARGET A CITY"},/*21*/
	{"FOR ME TO CONTROL"},/*22*/
	{"THE FILTERS WILL"},/*23*/
	{"HELP PINPOINT"},/*24*/
	{"ISSUES"}/*25*/
	
	


};



float remaining_time=0;
float temperature=50.01;
float temperature_adder=100;
float processes_done=0;

int overload=FALSE;
int most_infected_selection=0;
int fastest_spreading_selection=0;
volatile float overload_timer=0;

volatile float timer=0;

volatile float process_timer=0;
volatile float work_done_timer=0;

volatile int speed_counter = 0;

volatile float milli=0;




char msg[80];


      /*function to keep game updating user
      inputs at constant speed*/
      void increment_speed_counter(void)
      {
         speed_counter++;
		 
      }

      END_OF_FUNCTION(increment_speed_counter);


     
 void fps_proc(void)
{



   fps = frame_count;
   frame_count = 0;
 
  
	
	title_running+=0.025;

	timer+=0.01;
	process_timer+=0.01;

	if(overload==FALSE)
		
		work_done_timer+=0.025*(scrollbars[0].value*(1-scrollbars[3].value*0.5));
	else overload_timer+=0.01;


	milli++;


         }

END_OF_FUNCTION(fps_proc);



float get_milli_value()
{
	return milli;
}



void update_processing()
{


	remaining_time=(100-work_done_timer)*(1/(2.5*scrollbars[0].value*(1-scrollbars[3].value*0.5) ));

	if(work_done_timer>=100&&target==TRUE) 
	{
		
		target=FALSE;
		work_done_timer=0;
		process_timer=0;
		score+=city[selection].infected;
		city[selection].infected-=(city[selection].infected)*0.9;
		if(city[selection].infected==1)
		{
			city[selection].infected=0;
			score++;
		}

		score+=city[selection].rioters/2;
		city[selection].rioters-=city[selection].rioters*0.9;
		if(city[selection].rioters==1)
		{
			city[selection].rioters=0;
			score++;
		}

						generate_wave(FALSE, 5,0,5500,6500,PWM,0.001,650*2+(sin(DEG_2_RAD((int)(22*timer)%360))*150*2) );
						
						generate_wave(FALSE, 25,0,500,6500,NOISE,0.01,280*2+(sin(DEG_2_RAD((int)(38*timer)%360))*50*2) );
						stop_sweep();


	}
if(target==TRUE&&overload==FALSE)temperature_adder+=0.05*scrollbars[0].value;
if( (target==FALSE||overload==TRUE) && temperature_adder>0)temperature_adder-=0.05;



	temperature=temperature_adder+(128-scrollbars[3].value*128);
 if(temperature>255)temperature=255;

	if(temperature>200&&overload==FALSE&&target==TRUE)
	{
		if(rand()%100)
		{
			overload=TRUE;

		}
		overload_timer=0;


	}
	if(overload_timer>3&&overload_timer<4)generate_wave(TRUE, 30,0,50,50,PWM,0.001,100*2+(sin(DEG_2_RAD((int)(5*timer)%360))*50*2) );
	
	if(target==FALSE)overload_timer=0;
	if(overload_timer>200)
	{
		//temperature_adder=0;
		overload=FALSE;
		overload_timer=0;

			generate_wave(FALSE, 30,0,50,50,PWM,0.001,200*2+(sin(DEG_2_RAD((int)(5*timer)%360))*150*2) );
		
	}

}

void update_population(int c)
{

	int i=0;
	int j=c;
	int c2,c3=0;
	int chance_infection_spreads=3500;  
	int randomness_of_spread=0;
	float distance=0;
	float ratio_not_infected=0;
	float number_of_contacted_people=0;
	float percent_of_people_contacted=0;

	if(city[c].population>0) ratio_not_infected=1-(city[c].infected/city[c].population);

	for(c2=0;c2<10;c2++)
	{
		
		
		//number of non infected people contacted at this city


		distance=sqrt( ((city[c].pos.x-city[c2].pos.x)*(city[c].pos.x-city[c2].pos.x)) + ((city[c].pos.y-city[c2].pos.y)*(city[c].pos.y-city[c2].pos.y) ) );
		//if(distance>200)distance=200;

		number_of_contacted_people+=((float)city[c2].infected*0.0001*(float)city[c].population) /(distance+1) ;

		


		//chance_infection_spreads+= ( distance_multiplier*500 ) * ((float)(city[c2].infected));
		
		
	}

	if(number_of_contacted_people>50000) number_of_contacted_people=50000;

	//number_of_contacted_people*=ratio_not_infected;
	


	for(c2=0;c2<number_of_contacted_people;c2++)
	{

	randomness_of_spread=rand()%chance_infection_spreads;

	if(randomness_of_spread==10)

		city[c].infected++;
	
	}
		if(rand()%500==10)
		{
	if(city[c].rioters<city[c].population)city[c].rioters+=1+city[c].rioters;
	if(city[c].rioters>city[c].population)city[c].rioters=city[c].population;
		}
		
		if(city[c].infected>0)
			for(c2=0;(c2<(city[c].infected+city[c].rioters)&&c2<20000);c2++)
			{
				if(rand()%500==10)
				{
					if(city[c].population>0)city[c].population--;
					if(city[c].infected>0)city[c].infected--;
					if(city[c].rioters>0)city[c].rioters--;
					city[c].dead++;
				}
			}

	
    if(city[c].infected>city[c].population)city[c].infected=city[c].population;
	
	population+=city[c].population;
	infected+=city[c].infected;
	dead+=city[c].dead;
	rioters+=city[c].rioters;

	city[c].spread_chance=number_of_contacted_people;

	
 if(city[c].infected>city[most_infected_selection].infected)most_infected_selection=c;
 if(city[c].spread_chance>city[fastest_spreading_selection].spread_chance)fastest_spreading_selection=c;

if(city[c].infected==0)city[c].infected++;
if(infected==0)
{
city[c].infected=1;

		infected=1;
	}

}



        /*function for user inputs*/
void input()
{
float f_mouse_x=mouse_x;
float f_mouse_y=mouse_y;

int c=0;

	
	
		

			for(c=0;c<MAX_SCROLL+1;c++)
			{
		if(mouse_x>scrollbars[c].x && mouse_x<(scrollbars[c].x+scrollbars[c].w)
			&& mouse_y>scrollbars[c].y-5 && mouse_y<(scrollbars[c].y+scrollbars[c].h+5))
		{
			mouse_type=6;
			if (mouse_b&1) scrollbars[c].value=(f_mouse_x-scrollbars[c].x)/scrollbars[c].w;

			if (scrollbars[c].value<=0) scrollbars[c].value=0.05;
			if (scrollbars[c].value>=100) scrollbars[c].value=99.95;


		}
			
			}


			//EASTER EGG HERE
			//CHANGE TV CHANNEL
			//TO WATCH DIFFERENT
			//NEWS STATION
			//
			//
			//


			if(mouse_x>=300 && mouse_x<390
				&& mouse_y<=50)

			{
				mouse_type=6;
				if(one_shot_click==1)
				{

				if (channel==3) channel=4;
				else
					channel=3;

				}
			}


			for(c=0;c<9;c++)
			{
			if(mouse_x>=city[c].pos.x-15 && mouse_x<city[c].pos.x+15
				&& mouse_y>=city[c].pos.y-10 && mouse_y<city[c].pos.y+20)

			{
				mouse_type=6;
				if (one_shot_click==1&&target!=TRUE)
				{
					target=TRUE;
					selection=c;
					target_x=mouse_x;
					target_y=mouse_y;
					work_done_timer=0+processes_done*0.01;
					process_timer=0;
					processes_done+=1;

					
						generate_wave(TRUE, 5,0,500,500,PWM,0.01,450*2+(sin(DEG_2_RAD((int)(22*timer)%360))*150*2) );
						
						generate_wave(TRUE, 25,0,500,6500,NOISE,0.01,80*2+(sin(DEG_2_RAD((int)(38*timer)%360))*50*2) );
						
				}
		
			}
			}

			if(mouse_x>=400 && mouse_x<525
				&& mouse_y>320&& mouse_y<350)

			{
				mouse_type=6;
				if (one_shot_click==1)
				{
					filter=POPULATION;
					
				}
		
			}

			if(mouse_x>=525 && mouse_x<650
				&& mouse_y>320&& mouse_y<350)

			{
				mouse_type=6;
				if (one_shot_click==1)
				{
					filter=VIRUS;
					
				}
		
			}

			if(mouse_x>=650 && mouse_x<775
				&& mouse_y>320&& mouse_y<350)

			{
				mouse_type=6;
				if (one_shot_click==1)
				{
					filter=RIOTS;
					
				}
		
			}

		



}




void display_title()
{

float alpha=128;
int c=0;


	
drawing_mode(DRAW_MODE_TRANS ,NULL, 0,0);

alpha=164;
	set_trans_blender(225, 225, 225, alpha);




drawing_mode(DRAW_MODE_SOLID,NULL, 0,0);

clear_to_color(title_text,makecol(0,0,0));

sprintf(msg, "WELCOME!");
textout_centre_ex(title_text, font, msg, 128,(int)( 128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "TO THE FUTURE");
textout_centre_ex(title_text, font, msg, 128, (int)( 1*32+128-(float)(title_running*0.5)), makecol(255,2255,0),-1);

sprintf(msg, "THE YEAR 2090");
textout_centre_ex(title_text, font, msg, 128, (int)( 2*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "A SUPER COMPUTER");
textout_centre_ex(title_text, font, msg, 128, (int)( 3*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "NOW CONTROLS");
textout_centre_ex(title_text, font, msg, 128, (int)( 4*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "THE EARTH");
textout_centre_ex(title_text, font, msg, 128, (int)( 5*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "THERE HAS BEEN A");
textout_centre_ex(title_text, font, msg, 128, (int)( 6*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "VIRAL OUTBREAK");
textout_centre_ex(title_text, font, msg, 128, (int)( 7*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "IN THE COUNTRY");
textout_centre_ex(title_text, font, msg, 128, (int)( 8*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "CYBERTROL");
textout_centre_ex(title_text, font, msg, 128, (int)( 9*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "MANY MAY DIE IF");
textout_centre_ex(title_text, font, msg, 128, (int)( 10*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "NOT BROUGHT UNDER CONTROL");
textout_centre_ex(title_text, font, msg, 128, (int)( 11*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "IT IS YOUR JOB");
textout_centre_ex(title_text, font, msg, 128, (int)( 12*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "TO KEEP THE COMPUTER");
textout_centre_ex(title_text, font, msg, 128, (int)( 13*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "HAPPY");
textout_centre_ex(title_text, font, msg, 128, (int)( 14*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "AND HELP");
textout_centre_ex(title_text, font, msg, 128, (int)( 15*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "IT CONTROL THE");
textout_centre_ex(title_text, font, msg, 128, (int)( 16*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "OUTBREAK");
textout_centre_ex(title_text, font, msg, 128, (int)( 17*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "AND ANY RIOTS");
textout_centre_ex(title_text, font, msg, 128, (int)( 18*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "ALONG WITH");
textout_centre_ex(title_text, font, msg, 128, (int)( 19*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);

sprintf(msg, "OTHER PROBLEMS..");
textout_centre_ex(title_text, font, msg, 128, (int)( 20*32+128-(float)(title_running*0.5)), makecol(64,228,128),-1);


sprintf(msg, "CLICK MOUSE");
textout_centre_ex(title_text, font, msg, 128, (int)( 22*32+128-(float)(title_running*0.5)), makecol(225,225,225),-1);

quad3d_f(buffer, POLYTYPE_ATEX, title_text, &vtx_text[0],&vtx_text[1],&vtx_text[2],&vtx_text[3]);

}








/*This function is used to show the graphics*/
void display()
{

	int display_news_message=0;
if(game_1_over==FALSE)
{
	int c=0;

 stretch_sprite(buffer, datafile[0].dat, SCREEN_W / 2,
                        0, SCREEN_W / 2, SCREEN_H / 2);
 
 for(c=0;c<10;c++)
 {
 sprintf(msg, city[c].name);
 textout_centre_ex(buffer, font, msg, city[c].pos.x,city[c].pos.y,makecol(0,0,0),makecol(255,255,255));
 
 if(filter==POPULATION)
 {
 sprintf(msg, "%d",city[c].population);
 textout_centre_ex(buffer, font, msg, city[c].pos.x,city[c].pos.y+12,makecol(0,255,0),makecol(0,0,0));
 
 //sprintf(msg, "%.2f",city[c].spread_chance);
 //textout_centre_ex(buffer, font, msg, city[c].pos.x,city[c].pos.y+22,makecol(0,255,0),makecol(0,0,0));
 
 
 }

 if(filter==VIRUS)
 {
 sprintf(msg, "%d",city[c].infected);
 textout_centre_ex(buffer, font, msg, city[c].pos.x,city[c].pos.y+12,makecol(255,0,0),makecol(255,255,255));
 }

 if(filter==RIOTS)
 {
 sprintf(msg, "%d",city[c].rioters);
 textout_centre_ex(buffer, font, msg, city[c].pos.x,city[c].pos.y+12,makecol(0,0,0),makecol(255,255,255));
 }
 
 }
 
stretch_sprite(buffer, datafile[1].dat, 0,
                        SCREEN_H / 2, SCREEN_W/2, SCREEN_H / 2);


stretch_sprite(buffer, datafile[channel].dat, 0,
                        0, SCREEN_W/2, SCREEN_H / 2);

clear_to_color(news_alert,makecol(255,0,255));
 
sprintf(msg, "VIRUS OUTBREAK ALERT!!");
textout_ex(news_alert, font, msg, 128-((int)(400+(float)timer*10))%1024,0, makecol(0,0,0),-1);

stretch_sprite(buffer,news_alert, 5, 220, 390, 36);

clear_to_color(news_alert2,makecol(255,0,255));


 if((64-((int)((float)timer*2.5))%300)==-220)
 {
	 
 if(allow_switching==TRUE)news_alert_selection++;
 allow_switching=FALSE;
 }
 else
	 allow_switching=TRUE;
 
 if(news_alert_selection>8)news_alert_selection=0;
display_news_message=news_alert_selection;

if(display_news_message==0) sprintf(msg, "%d ARE INFECTED",infected);
if(display_news_message==1) sprintf(msg, "STAY INDOORS");
if(display_news_message==2) sprintf(msg, "%d RIOTERS IN STREETS",rioters);
if(display_news_message==3) sprintf(msg, "%d PEOPLE HAVE DIED",dead);
if(display_news_message==4) sprintf(msg, "CITY %s IS MOST INFECTED",city[most_infected_selection].name);
if(display_news_message==5) sprintf(msg, "CITY %s INFECTION SPREADING",city[fastest_spreading_selection].name);
if(display_news_message==6) sprintf(msg, "STAY TUNED");
if(display_news_message==7) sprintf(msg, "SUPER COMPUTER HARD AT WORK");
if(display_news_message==8) sprintf(msg, "DO NOT RIOT");

textout_ex(news_alert2, font, msg, 64-((int)((float)timer*2.5))%300,0, makecol(255,0,0),-1);

stretch_sprite(buffer,news_alert2, 5, 265, 390, 292-265);


 for(c=0;c<MAX_SCROLL;c++)
 {

	 if(c!=1)
	 {
rect(buffer,scrollbars[c].x,scrollbars[c].y,scrollbars[c].x+scrollbars[c].w,scrollbars[c].y+scrollbars[c].h,makecol(255,255,255));
rectfill(buffer,scrollbars[c].x+1,scrollbars[c].y+1,scrollbars[c].x+scrollbars[c].w*scrollbars[c].value,scrollbars[c].y+scrollbars[c].h-1,makecol(255,225,0));
rectfill(buffer, scrollbars[c].x+(scrollbars[c].w*scrollbars[c].value)-5,scrollbars[c].y-5,scrollbars[c].x+(scrollbars[c].w*scrollbars[c].value)+5,scrollbars[c].y+scrollbars[c].h+5,makecol(64,64,255));

 

 sprintf(msg, scrollbars[c].text);
 textout_centre_ex(buffer, font, msg, scrollbars[c].x+(scrollbars[c].w/2), scrollbars[c].y+(scrollbars[c].h/2), makecol(0,0,0),-1);
	 }
 }

 sprintf(msg, "");
 textout_centre_ex(buffer, font, msg, 190,90,makecol(255,255,255),-1);

 clear_to_color(comp_text,makecol(scrollbars[2].value*225,scrollbars[2].value*225,scrollbars[2].value*225));
 
 if(target!=TRUE)
 {
	 int text_color=makecol((int)(sin(DEG_2_RAD(timer*50))*32+64),255-scrollbars[2].value*225,(int)(sin(DEG_2_RAD(timer*120))*32+64));
	for(c=0;c<MAX_COMPUTER_TALK;c++)
	{
		sprintf(msg, computer_talk[c]);
		textout_ex(comp_text, font, msg, 10,90+c*35-(((int)(timer*2.5)/35)*35),text_color,-1);
	}
 }

 if(target==TRUE)
 {
	 int text_color=makecol((int)(sin(DEG_2_RAD(timer*50))*32+64),255-scrollbars[2].value*225,(int)(sin(DEG_2_RAD(timer*120))*32+64));
	
	 sprintf(msg, "Processing...%.2f %%done",work_done_timer);
 textout_ex(comp_text, font, msg, 10,10,text_color,-1);

 sprintf(msg, "Time Elasped %.2f s",process_timer*0.10);
 textout_ex(comp_text, font, msg, 10,20,text_color,-1);

 sprintf(msg, "Remaining Time %.2f s",remaining_time*0.10);
 textout_ex(comp_text, font, msg, 10,30,text_color,-1);

 if(overload==TRUE)
 {

 sprintf(msg, "OVERLOAD");
 textout_ex(comp_text, font, msg, 10,40,makecol(255,0,0),-1);

 sprintf(msg, "REBOOTING...%.2f",overload_timer*0.10);
 textout_ex(comp_text, font, msg, 10,50,makecol(255,0,0),-1);


 }





 
 
 
 }


  stretch_sprite(buffer,comp_text, 20, 317, 380-20, 460-312);

  if(target==TRUE)
  {
	  circle(buffer, target_x,target_y,20,makecol(255,0,0));
	  line(buffer,target_x,target_y-25,target_x,target_y+25,makecol(255,64,32));
	  line(buffer,target_x-25,target_y,target_x+25,target_y,makecol(255,64,32));

  }

  rectfill(buffer,400,320,525,350,makecol(225,225,225));
  rectfill(buffer,525,320,650,350,makecol(225,225,225));
  rectfill(buffer,650,320,775,350,makecol(225,225,225));

if(filter==POPULATION) rectfill(buffer,400+5,320+5,525-5,350-5,makecol(225,225,0));
if(filter==VIRUS) rectfill(buffer,525+5,320+5,650-5,350-5,makecol(225,225,0));
if(filter==RIOTS) rectfill(buffer,650+5,320+5,775-5,350-5,makecol(225,225,0));

sprintf(msg, "FILTERS");
 textout_centre_ex(buffer, font, msg, 585,310,makecol(255,255,255),-1);


sprintf(msg, "POPULATION");
 textout_centre_ex(buffer, font, msg, 450,330,makecol(0,0,0),-1);

 sprintf(msg, "VIRUS");
 textout_centre_ex(buffer, font, msg, 585,330,makecol(0,0,0),-1);

 sprintf(msg, "RIOTS");
 textout_centre_ex(buffer, font, msg, 710,330,makecol(0,0,0),-1);

clear_to_color(statistics,makecol(0,0,0));
 
 sprintf(msg, "POP. %d",population);
 textout_ex(statistics, font, msg, 0,10,makecol(255,255,255),-1);

 sprintf(msg, "INFECTED %d",infected);
 textout_ex(statistics, font, msg, 0,20,makecol(255,255,255),-1);
 
 sprintf(msg, "RIOTERS %d",rioters);
 textout_ex(statistics, font, msg, 0,30,makecol(255,255,255),-1);

 sprintf(msg, "DEAD %d",dead);
 textout_ex(statistics, font, msg, 0,40,makecol(255,255,255),-1);

 sprintf(msg, "SCORE %d",score);
 textout_ex(statistics, font, msg, 0,50,makecol(255,255,255),-1);

 
 sprintf(msg, "TEMP %.2fc",temperature);
 textout_ex(statistics, font, msg, 0,60,makecol(temperature,255-temperature,0),-1);

 stretch_sprite(buffer,statistics, 400, 350, 400, 250);

 
}


if(show_in_game_title==TRUE)

{


}


if(game_1_over==END)

{

floodfill(buffer,0,0,makecol(20,25,15));


sprintf(msg, "GAME OVER");
textout_centre_ex(buffer, font, msg, SCREEN_W/2.0f, SCREEN_H/2.0f, makecol(128,128,128),-1);


}



}






RGB_MAP rgb_table;

/* lighting color mapping table */
COLOR_MAP light_table;


void print_progress(int pos)
{
   /*prints the stars that show the progress of creating the color maps*/
   if ((pos & 3) == 3) {
      printf("*");
      fflush(stdout);
   }
}

int main(int argc, char *argv[])
{
 
 PALLETE pal;
 char buf[256];

 int sound =0;
 int c;

 int bpp =24;


 
 
 

 
 


 
     /*This section installs allegro*/
     allegro_init();
     install_keyboard();
     install_mouse();
     install_timer();

     srand(time(NULL));    /*a timer used to create random boxes*/

    /* I took this section of code from the 3d bouncing cubes example
    that comes with allegro*/
    /* color 0 = black */
   pal[0].r = pal[0].g = pal[0].b = 0;

   /* copy the desktop pallete */
   for (c=1; c<64; c++)
      pal[c] = desktop_pallete[c];

   /* make a red gradient */
   for (c=64; c<96; c++) {
      pal[c].r = (c-64)*2;
      pal[c].g = pal[c].b = 0;
   }

   /* make a green gradient */
   for (c=96; c<128; c++) {
      pal[c].g = (c-96)*2;
      pal[c].r = pal[c].b = 0;
   }

   /* set up a greyscale in the top half of the pallete */
   for (c=128; c<256; c++)
      pal[c].r = pal[c].g = pal[c].b = (c-128)/2;

   /* build rgb_map table */
   printf("Generating rgb_map table:\n");
   printf("<................................................................>\r<");
   create_rgb_table(&rgb_table, pal, print_progress);
   rgb_map = &rgb_table;
   printf("\n\n");

   /* build a lighting table */
   printf("Generating lighting table:\n");
   printf("<................................................................>\r<");
   create_light_table(&light_table, pal, 0, 0, 0, print_progress);
   color_map = &light_table;
   printf("\n");


  
     /*sets the color depth*/
  
   bpp=16;
   set_color_depth(bpp);
   if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0) != 0) {
      bpp=32;
      set_color_depth(bpp);
      if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0) != 0) { 
		  bpp=24;
      set_color_depth(bpp);
      if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0) != 0) {  
      bpp=16;
   set_color_depth(bpp);
   if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) != 0) {
      bpp=32;
      set_color_depth(bpp);
      if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) != 0) { 
		  bpp=24;
      set_color_depth(bpp);
      if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) != 0) {  
      allegro_message("could not set_gfx_mode(): %s\n",allegro_error);
         return 1;
        }
      }
	 }
	  }}}


   /*sets the palette to how it is set by the pointer to pal*/
   set_pallete(pal);
   
replace_filename(buf, argv[0], "data/datafile.dat", sizeof(buf));
   datafile = load_datafile(buf);
   if (!datafile) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
     allegro_message ("Error loading %s!\n\n", buf);
      return 12;
   }

   /* install a sound driver*/ 
   if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Error initialising sound system\n%s\n", allegro_error);
      return 1;
   }


if(init_stream()==1)
   {
	   set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
       allegro_message("Error creating audio stream!\n");
	   return 1;
   }




      

    install_int(fps_proc, 1);

    /* sets the game speed to 30 frames per second*/
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));
    /*locks timer variables explained in allegro manuals*/
    LOCK_VARIABLE(speed_counter);
    LOCK_FUNCTION(increment_speed_counter);

    LOCK_VARIABLE(frame_count);
    LOCK_VARIABLE(fps);
	LOCK_VARIABLE(overload_timer);
	LOCK_VARIABLE(timer);
	LOCK_VARIABLE(process_timer);
	LOCK_VARIABLE(work_done_timer);
	

   LOCK_FUNCTION(fps_proc);



	


   /*creates a buffer the same size as the screen*/
   buffer = create_bitmap (800,600);
   title_text=create_bitmap(256,128);
   comp_text=create_bitmap(256,64);
   statistics=create_bitmap(128,96);
   news_alert=create_bitmap(128,16);
   news_alert2=create_bitmap(64,8);

   /*sets the background of the text to transparent*/
   //text_mode(-1);
   
   /*sets the digital and midi volumes for the game*/
   set_volume(255, 70*2);



while(milli<1000)
{
for(c=0;c<42;c++)
generate_wave(FALSE, c,0,500,2500,PWM,0.02/(c*3+1),2000);
}

start_sweep_flag=TRUE;

   /*This is the main game loop*/

show_title=TRUE;
show_in_game_title=FALSE;




    while (!key[KEY_ESC])
    {
                /*this while statement keeps the game at a constant speed*/
            while (speed_counter > 0)
            {

						
						if(start_sweep_flag==TRUE)do_sweep(1);
						start_sweep_flag=FALSE;

					if(show_title==TRUE)
					{
						generate_wave(TRUE, 16,0,3500,6500,PWM,0.001,1850*2+(sin(DEG_2_RAD((int)(22*timer)%360))*450*2) );
						generate_wave(TRUE, 25,0,500,6500,NOISE,0.01,150*2+(sin(DEG_2_RAD((int)(38*timer)%360))*150*2) );
					}	
						
						update_music();

				if(mouse_b&1 && one_shot_click==1)one_shot_click=2;
				if(mouse_b&1 && one_shot_click==0)one_shot_click=1;
				if(!(mouse_b&1))one_shot_click=0;

				


				if(show_title==FALSE&&show_in_game_title==FALSE&&game_1_over==FALSE)
				{
					mouse_type=5;
                input();   /*this function checks for user input*/
				
				population=0;
				rioters=0;
				dead=0;
				infected=0;
				for(c=0;c<10;c++)
				update_population(c);

				update_processing();
				
				

			
                }

				if(show_title==FALSE&&show_in_game_title==TRUE&&one_shot_click==1)
				{
					show_in_game_title=FALSE;
				
				}

				if(show_title==TRUE&&one_shot_click==1) 
				{
					show_title=FALSE;
					generate_wave(FALSE, 16,0,3500,6500,PWM,0.001,1850*2+(sin(DEG_2_RAD((int)(22*timer)%360))*450*2) );
					generate_wave(FALSE, 25,0,500,6500,NOISE,0.01,150*2+(sin(DEG_2_RAD((int)(38*timer)%360))*150*2) );
					stop_sweep();
					timer=0;
					
				}

			
		


          speed_counter--; /*The speed counter is subtracted every scan that the
                           speed counter is greater than zero and added by the
                           bps function so that when the speed is subtracted
                           more than the bps function adds the while statement
                           will end and display the graphics*/
          /*this line changes the music frequency as the player gets more points*/
          
            }
             /*This function will draw the background and boxes to a buffer*/
             if(show_title==FALSE)display();
			 
			 
			 
			 if(show_title==TRUE) display_title();


            //show_mouse(buffer);
			 draw_sprite(buffer,datafile[mouse_type].dat,mouse_x,mouse_y);
             /*draws the buffer to the screen*/
           blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
           


  
		   
		   show_mouse(NULL);
             /*clears the buffer to a background color*/
             clear_to_color(buffer,makecol(0,0,0));
             /*if the user gets a point the background will be a different
             color for a few seconds*/
      }

start_sweep_flag=FALSE;
stop_sweep();

for(c=0;c<42;c++)
generate_wave(FALSE, c,0,500,2500,PWM,0.02/(c*3+1),2000);

	silence();

stop_stream();

unload_datafile(datafile);
destroy_bitmap(buffer);
destroy_bitmap(title_text);
destroy_bitmap(comp_text);
destroy_bitmap(news_alert);
destroy_bitmap(news_alert2);

return 0;
}

END_OF_MAIN();
