

extern void generate_wave(int enable, int note, float freq_offset, float attack, float decay, int type, float pwm_speed, float volume);
extern void do_sweep(int type);
extern void stop_sweep();

extern int start_sweep_flag;

extern int init_stream();
extern int update_music();
extern void stop_stream();
extern float get_milli_value();
extern void silence();
extern void reset_waves();


#define BUFFER_SIZE  1024
#define SAMPLE_SPEED 44100

#ifndef M_PI
   #define M_PI   3.1415926535897932384626433832795
#endif
#define RAD_2_DEG(x) ((x) * 180 / M_PI)
#define DEG_2_RAD(x)    ((x) * M_PI / 180)

#define PERCENT_COS(x)  (1-cos(((x)*90) * M_PI / 180))
#define PERCENT_SIN(x)  sin(((x)*90) * M_PI / 180)


#define UPDATES_PER_SECOND  (float)(SAMPLE_SPEED/BUFFER_SIZE)

#define INC_PER_UPDATE  (float)(360/UPDATES_PER_SECOND)

#define FREQ_MULT  (float)(INC_PER_UPDATE/(0.0001*BUFFER_SIZE))
 


#define NOTE_MULT 1.05946309


#define NOISE 3
#define PWM 5 

