


#include "global.h"

#include "allegro.h"
#include <math.h>


int int_rand_vol=1;
float rand_vol=1;

int check_the_sweep;
#define BUFFER_SIZE  1024
#define SAMPLE_SPEED 44100



#define UPDATES_PER_SECOND  (float)(SAMPLE_SPEED/BUFFER_SIZE)

#define INC_PER_UPDATE  (float)(360/UPDATES_PER_SECOND)

#define FREQ_MULT  (float)(INC_PER_UPDATE/(0.0001*BUFFER_SIZE))
 


#define NOTE_MULT 1.05946309

 

#define PERCENT_COS(x)  (1-cos(((x)*90) * M_PI / 180))
#define PERCENT_SIN(x)  sin(((x)*90) * M_PI / 180)


float show_freq_mult =FREQ_MULT; 
int start_sweep_flag=0;

float milli_used=0;

                            
    char msg[80];

	

int c=0;
int delay_time=20;
float inc=0;
float freq=81;
float volume=1;
float p_float=0;
float p_float_x100=0;
float plot[3000];
int do_square=0;

float xx=0;

float d=0;
int count=0;
float frequency_mod=0;

float attack_percent=0;
float decay_percent=0;





float square_wave[360];








struct PULSE_WIDTH_MOD
{
	float percent;
	float mod_speed;
	float low_level;
	float high_level;
	int flag;
};

#define PWM_DIR_NEG 1
 

 struct WAVE {
	int enable;
	float inc;
	float freq;
	float freq_stored;
	float old_freq_offset;
	float new_freq_offset;
	float attack;
	float attack_timer;
	float decay;
	float decay_timer;
	int attack_type;
	int decay_type;
	float timer;
	float volume;
	float volume_stored;
	int type;
		
	struct PULSE_WIDTH_MOD pwm;
	
	int key;
	
	
 
 };

struct WAVE wave[62];

struct WAVE use_wave[62];




int p[BUFFER_SIZE];

unsigned short *pold;

float p_add=0;

AUDIOSTREAM *stream;


	 /*each second the wave form is updated this many times
	 sample speed/buffer size = 44100/1024 = 43.06640625 times each second
	 frequency=cycles/second

  	1hz=(1cycle)/per second

  1 cycle = 360degrees
  to get 1hz the wave is incremented to be 360degree over 43.06640625 times each second
  increments =  360degrees/(43.06640625)=8.35918367346938775510204081632653 
		

to get the wave to shift 8.359183 degrees per update
  
	d is updated by 0.0001 (1024)times the buffer size each update
    d is incremented by 0.0001 x 1024 = 0.1024	
	8.359183degrees shifted = (0.1024 increments) * multiplier
	  multiplier = 81.6326
		
		  to have frequency on display = 1hz
		  actually be 1hz multiply number by multiplier
	
	 
	 */ 



int i=0;





float new_frequency=0;
float new_frequency_mod=0;
float old_frequency_mod=0;
float add_frequency=0;
float newer_frequency=0;

float pwm_percent_inc=0;




     


     
void reset_waves()
{
	int c=0;

	milli_used=get_milli_value();

	for(c=0;c<42;c++)
	use_wave[c].decay_timer=milli_used-1000;



}






void do_wave()
{

  

  use_wave[c].inc+=0.0001;


if(use_wave[c].freq<0)	use_wave[c].freq=0;

	 frequency_mod=use_wave[c].inc*use_wave[c].freq*(FREQ_MULT);
	 frequency_mod=((int)frequency_mod)%360;
	 if(use_wave[c].inc>=15&&(frequency_mod<20))
			{
		if(p[i-1]>31500&&p[i-1]<33500&&p!=0)use_wave[c].inc=0;
		 
		 
		 	 }

if(use_wave[c].type==NOISE)
	{

	

rand_vol=use_wave[c].volume;
int_rand_vol=rand_vol;
if(int_rand_vol<1)int_rand_vol=1;
p[i]+=(rand()%(int_rand_vol))-(use_wave[c].volume*0.5);
p_add=(rand()%(int_rand_vol))-(use_wave[c].volume*0.5);
	}	 

if(use_wave[c].type==PWM)
	{
	float at_percent=(frequency_mod/360)*100;
	int high_or_low=0;

	if(pow(use_wave[c].freq,1-NOTE_MULT)>0)
	{
		if (!(use_wave[c].pwm.flag&PWM_DIR_NEG)) use_wave[c].pwm.percent+=use_wave[c].pwm.mod_speed/(pow(use_wave[c].freq,1-NOTE_MULT));
		else use_wave[c].pwm.percent-=use_wave[c].pwm.mod_speed/(pow(use_wave[c].freq,1-NOTE_MULT));
	}
	
	if(use_wave[c].pwm.percent>use_wave[c].pwm.high_level && (!(use_wave[c].pwm.flag&PWM_DIR_NEG)) )
	{
		use_wave[c].pwm.percent=use_wave[c].pwm.high_level-(use_wave[c].pwm.percent-use_wave[c].pwm.high_level);
		use_wave[c].pwm.flag+=PWM_DIR_NEG;
	}

	if(use_wave[c].pwm.percent<use_wave[c].pwm.low_level && (use_wave[c].pwm.flag&PWM_DIR_NEG) )
	{
		use_wave[c].pwm.percent=use_wave[c].pwm.low_level+(use_wave[c].pwm.low_level-use_wave[c].pwm.percent);
		use_wave[c].pwm.flag-=PWM_DIR_NEG;
	}
		
		
	
	
	if(at_percent<use_wave[c].pwm.percent) high_or_low=1;

p[i]+= high_or_low * use_wave[c].volume;
p_add= high_or_low * use_wave[c].volume;
	}




plot[i]=(p[i]-32767)/100;
		
  


}
       



void vol_env_att()
{
if(use_wave[c].enable==TRUE)
	{

if(use_wave[c].attack_timer>=milli_used) attack_percent=( (use_wave[c].attack-(use_wave[c].attack_timer-milli_used))/use_wave[c].attack);
else attack_percent=1;

if(use_wave[c].attack_type==1) attack_percent=PERCENT_SIN(attack_percent);
if(use_wave[c].attack_type==2) attack_percent=PERCENT_COS(attack_percent);


use_wave[c].volume=use_wave[c].volume_stored*attack_percent;
use_wave[c].decay_timer=use_wave[c].decay*attack_percent+milli_used;
	}


}





void vol_env_dec()

	{
if(use_wave[c].decay_timer>milli_used) decay_percent=( (use_wave[c].decay_timer-milli_used)/use_wave[c].decay);
else decay_percent=0;

if(use_wave[c].decay_type==1) decay_percent=PERCENT_SIN(decay_percent);
if(use_wave[c].decay_type==2) decay_percent=PERCENT_COS(decay_percent);



use_wave[c].attack_timer=use_wave[c].attack*(1-decay_percent)+milli_used;
if(use_wave[c].attack_timer>=milli_used) attack_percent=( (use_wave[c].attack-(use_wave[c].attack_timer-milli_used))/use_wave[c].attack);

use_wave[c].volume=use_wave[c].volume_stored*decay_percent;



	}



void update_wave()
{
	

	for(c=0;c<42;c++)
	{
		float check_mod_current=use_wave[c].inc*(wave[c].freq_stored+wave[c].old_freq_offset)*(FREQ_MULT);
		float check_mod_new=use_wave[c].inc*(wave[c].freq_stored+wave[c].new_freq_offset)*(FREQ_MULT);

		check_mod_current=(int)(check_mod_current)%360;
		check_mod_new=(int)(check_mod_new)%360;


		if(check_mod_current+30>check_mod_new && check_mod_current-30<check_mod_new)
		{
			wave[c].old_freq_offset=wave[c].new_freq_offset;

		}
	use_wave[c].enable=wave[c].enable;


	use_wave[c].freq_stored=wave[c].freq_stored+wave[c].old_freq_offset;

	use_wave[c].freq=wave[c].freq_stored+wave[c].old_freq_offset;

	use_wave[c].volume_stored=wave[c].volume_stored;



	use_wave[c].attack=wave[c].attack;
	use_wave[c].decay=wave[c].decay;
	use_wave[c].attack_type=wave[c].attack_type;
	use_wave[c].decay_type=wave[c].decay_type;



    
	use_wave[c].type=wave[c].type;

	use_wave[c].pwm.high_level=wave[c].pwm.high_level;
	use_wave[c].pwm.low_level=wave[c].pwm.low_level;
	use_wave[c].pwm.mod_speed=wave[c].pwm.mod_speed;
	
	}

}

 
void generate_wave(int enable, int note,float freq_offset, float attack, float decay, int type, float pwm_speed, float volume)
{

c=note;

if(wave[c].enable==FALSE&&enable==TRUE)
{
	
	use_wave[c].attack_timer=attack*(1-decay_percent)+milli_used;
	wave[c].new_freq_offset=0;
	wave[c].old_freq_offset=0;

}


if(milli_used>1000&&enable==TRUE)
{
	wave[c].enable=TRUE;
}
else wave[c].enable=FALSE;

if(wave[c].enable==TRUE)
{
	wave[c].volume_stored=volume;

	wave[c].new_freq_offset=freq_offset;


	

	wave[c].attack=attack;
	wave[c].decay=decay;
	wave[c].attack_type=wave[c].attack_type;
	wave[c].decay_type=wave[c].decay_type;

	wave[c].type=type;

	wave[c].pwm.high_level=wave[c].pwm.high_level;
	wave[c].pwm.low_level=wave[c].pwm.low_level;
	wave[c].pwm.mod_speed=pwm_speed;
}	



}

void do_sweep(int type)
{
if(type==1)	voice_sweep_frequency(stream->voice, 8000, 10000);
if(type==2) voice_set_frequency(stream->voice, 11000);
			
if(type==3) voice_set_frequency(stream->voice, (int)(44100+sin(DEG_2_RAD(milli_used*0.25))*2500) );
}

void stop_sweep()
{

voice_stop_frequency_sweep(stream->voice);
voice_set_frequency(stream->voice, 44100);
}

int init_stream()
{



int updates = 0;
int val = 0;
c=0;





   /* create an audio stream */
   stream = play_audio_stream(BUFFER_SIZE, 16, FALSE, SAMPLE_SPEED, 255, 128);
   if (!stream) {
      
      return 1;
   }


 
voice_set_priority(stream->voice ,255);
 

  
for(count=0;count<360;count++)
	{

if(count<180)square_wave[count]=0;
if(count>=180)square_wave[count]=1;

	}




memset(&wave,0,sizeof(struct WAVE));
memset(&use_wave,0,sizeof(struct WAVE));


for(c=0;c<42;c++)
{
	wave[c].attack=2780;
	wave[c].decay=2750;

    wave[c].freq_stored=110*pow(NOTE_MULT,c);
	wave[c].volume_stored=6000;
	wave[c].type=PWM;
	

	wave[c].pwm.high_level=75;
	wave[c].pwm.low_level=25;
	wave[c].pwm.mod_speed=0.02/(c*3+1);
	use_wave[c].pwm.percent=wave[c].pwm.low_level;





}


return 0;

}


void silence()
{


pold = get_audio_stream_buffer(stream);

		
		
  
      if (pold!=NULL)
		{
 
			/* if so, generate a bit more of our waveform... */
			for (i=0; i<BUFFER_SIZE; i++)
			{

				p[i]=32767;
				p_add=0;

				pold[i]=p[i];

			}

		free_audio_stream_buffer(stream);
		}
}

int update_music()
{
	


		voice_set_pan(stream->voice, (int)(128+sin(DEG_2_RAD(milli_used*0.03))*16) );

		pold = get_audio_stream_buffer(stream);

		milli_used=get_milli_value();
		update_wave();
		
  
        
		
 if(pold!=NULL)
      do 
	  {
	
 
			/* if so, generate a bit more of our waveform... */
			for (i=0; i<BUFFER_SIZE; i++)
			{

				p[i]=32767;
				p_add=0;

				for(c=0;c<42;c++)
				{
					new_frequency=use_wave[c].freq_stored;
					if(use_wave[c].enable==FALSE&&use_wave[c].decay_timer<milli_used) 
					{
						use_wave[c].attack_timer=use_wave[c].attack+milli_used;
					}

					if(use_wave[c].enable==TRUE)
					{
						vol_env_att();
					}

					if(use_wave[c].decay_timer>=milli_used&&use_wave[c].enable==FALSE)
					{
						vol_env_dec();
					}

					if(use_wave[c].enable==FALSE&&use_wave[c].decay_timer<milli_used)use_wave[c].inc=0;

					if(use_wave[c].enable==TRUE||use_wave[c].decay_timer>=milli_used) 
					{
						do_wave();
					}
					else
					{
						use_wave[c].freq=use_wave[c].freq_stored;
						use_wave[c].inc=0;
					}
				}
				
				if(p[i]>=65534)pold[i]=65534;
				if(p[i]<=0)pold[i]=0;
				if(p[i]>0&&p[i]<65534)pold[i]=p[i];

			}
		
		free_audio_stream_buffer(stream);
		pold = get_audio_stream_buffer(stream);
		}
	    while(pold!=NULL);

		return 0;
		
 }



	
void stop_stream()
{
	
	stop_audio_stream(stream);
}
